<script>
    import Meeting from './Meeting.svelte';
    import IntervalInput from './IntervalInput.svelte';
    import { getRecordings } from '../routes/_rec';

    export let showSelect = false;
    export let selection = {};

    let from;
    let to;

    let meetings;
    let meetingsPromice;
    let meetingList;

    let selectAllChosen = false;

    const getMeetings = async () => {
        const resp = await getRecordings({
            from, to,
        });
        meetings = resp.data;
        return resp.data;
    };

    const onSelectionChange = (e) => {
        if (!e.detail) {
            selectAllChosen = false;
        }
    };

    const onSelectAllToggle = (e) => {
        meetings.forEach((m) => {
            selection[m.uuid] = e.target.checked;
        });
    };

    // /*
    const clickAll = (elems) => {
        let interval;
        function d(es) {
            const e = es.pop();
            e.click();
            if (es.length === 0) {
                clearInterval(interval);
            }
        }

        interval = setInterval(d, 300, elems);
    };
    // */

    /*
    function download(filename, text) {
        const element = document.createElement('a');
        element.setAttribute('href', `data:text/plain;charset=utf-8,${encodeURIComponent(text)}`);
        element.setAttribute('download', filename);

        element.style.display = 'none';
        document.body.appendChild(element);

        element.click();

        document.body.removeChild(element);
    }
    */

    const downLoadSelected = () => {
        const selectedMeetings = meetings.filter((m) => !!selection[m.uuid]);
        const recordings = selectedMeetings.reduce((s, i) => [...s, ...i.recording_files], []);
        // const recorging_urls = recordings.reduce((s, i) => `${s}${i.download_url}\n`, '');
        // download(`meetng-recordings__${from}-${to}.txt`, recorging_urls);
        const elems = recordings.map((r) => meetingList.querySelector(`a[data-recid="${r.id}"]`));
        clickAll(elems);
    };

    $: console.log({ from });
    // $: console.log({ selection });

</script>


<div>
    <h2 class="header">Meetings</h2>

    <main>
        <fieldset class="retrieve-fs">
            <legend>Retrieve</legend>
            <div class="retrieve__fields">
                <div class="interval">
                    <IntervalInput bind:from bind:to/>
                </div>
                <div class="get">
                    <button class="get__button" on:click="{() => { meetingsPromice = getMeetings(); }}" disabled="{!from}">Retrieve</button>
                </div>
            </div>
        </fieldset>
        
        <fieldset class="actions-fs">
            <legend>Actions</legend>
            <div class="actions">
                <div class="download">
                    <button class="download__button" on:click="{() => downLoadSelected()}" disabled="{!from}">Download</button>
                </div>
            </div>
        </fieldset>

        <div class="sep"></div>

        <div class="resp">
            {#if meetingsPromice}
                {#await meetingsPromice}
                    <div class="resp__await">Loading....</div>
                {:then ms}
                    <div class="resp__then">
                        <div class="select-all-conf">
                            <label>
                                select all:
                                <input type="checkbox" bind:checked="{selectAllChosen}" on:change="{onSelectAllToggle}"/>
                            </label>
                        </div>
                        <div class="meetings-list" bind:this="{meetingList}">
                            {#each ms as m,i (m.uuid)}
                                <div class="meeting">
                                    <Meeting
                                        meeting="{m}"
                                        bind:selected="{selection[m.uuid]}"
                                        {showSelect}
                                        on:selection-change="{onSelectionChange}"
                                    />
                                </div>
                            {/each}
                        </div>
                    </div>
                {:catch e}
                    <div class="resp__error">
                        Error in loading
                    </div>
                {/await}
            {/if}
        </div>
    </main>

</div>


<style>

    .header {
        color: var(--c-p);
        background-color: var(--c-sd);
        margin-top: 0em;
        text-align: center;
    }

    fieldset {
        margin: 0 auto 0.7em auto;
    }

    legend {
        color: var(--c-s);
    }

    .retrieve__fields {
        display: grid;
        grid-template-columns: 1fr  auto;
        justify-content: space-between;
    }

    .resp {
        margin: 0.3em auto;
    }

    .resp__await {
        text-align: center;
    }

    .select-all-conf {
        display: flex;
        justify-content: flex-end;
        padding: 0.15em 1.5em;
        background: var(--c-surface);
        color: var(--c-s);
        font-size: 1em;
        font-weight: bold;
        margin-bottom: 0.5em;
        margin-top: 0.75em;
    }

    .select-all-conf input {
        height: 0.9em;
        width: 0.9em;
    }

    .meeting {
        border: 1px dashed blue;
        margin-bottom: 1.5em;
        border-radius: 0.5em;
        padding: 0.5em;
    }

    main {
        max-width: 35.8em;
        margin: 0 auto 0 auto;
    }

    .sep {
        height: 0.3em;
        background: var(--c-s);
    }

</style>
